CCFileUtils:sharedFileUtils():addSearchPath("hd/")

JSON = require "lua/JSON.lua"
--IMG_DIR_ADV = "/mnt/sdcard/Pictures/Nightmare-Harem-testlua/Story/adv/"
--IMG_DIR_CHARA = "/mnt/sdcard/Pictures/Nightmare-Harem-testlua/Story/chara/"
--IMG_DIR_ETC = "/mnt/sdcard/Pictures/Nightmare-Harem-testlua/Story/etc/"
IMG_DIR_ADV = "Story/adv/"
IMG_DIR_CHARA = "Story/chara/"
IMG_DIR_ETC = "Story/etc/"

-- debug Auto touch mode
-- 1:on 0:off
local AUTO_TOUCH_MODE = 0

-- debug view script
-- 1:on 0:off
local DEBUG_VIEW_SCRIPT = 1

local function lualog(...)
    print(string.format(...))
end

-- POS argument --
-- majika --
--local CHARA_POS_DIR_OVER_LEFT = 0
--local CHARA_POS_DIR_LEFT = 1
--local CHARA_POS_DIR_CENTER = 2
--local CHARA_POS_DIR_RIGHT = 3
--local CHARA_POS_DIR_OVER_RIGHT = 4
--local FACE_ID_BASE_ADD = 0
--local BG_POS_AJUST = 0

-- henbou --
local BG_POS_AJUST = 10
local CHARA_POS_DIR_OVER_LEFT = -2
local CHARA_POS_DIR_LEFT = -1
local CHARA_POS_DIR_CENTER = 0
local CHARA_POS_DIR_RIGHT = 1
local CHARA_POS_DIR_OVER_RIGHT = 2

local FACE_ID_BASE_ADD = 10000

-- resource id --
local LAYER_MSG = 1
	local IMG_MSG = 1
	local IMG_NAR = 2
	local LABEL_MSG_LINE = 3
	local IMG_STAR = 6
	
local LAYER_NAME = 2
	local IMG_NAME = 1
	local LABEL_NAME = 2

local IMG_FAST = 3
local IMG_SHUTTER = 5
local IMG_LOW_BG = 100
local IMG_LOW_CHARA = 200

local IMG_LOW_FG = 300

local TOP_BK_FRAME = 500
local BOTTOM_BK_FRAME = 501

local LAYER_IF = 6

local OBJ_ANIMATION_MESSAGE = 1000
local OBJ_ANIMATION_MESSAGE_1 = OBJ_ANIMATION_MESSAGE + 1
local OBJ_ANIMATION_MESSAGE_2 = OBJ_ANIMATION_MESSAGE + 2
local OBJ_ANIMATION_MESSAGE_3 = OBJ_ANIMATION_MESSAGE + 3


-- setting maximam resource --
local MAX_BG = 2
local MAX_CHARA = 4
--local MAX_CHARA_FACE_PARTS = {}

local CHARA_FACE_PARTS = {}

-- animation frame and speed --
local STAR_ANIMATION_FRAME = 4
local STAR_ANIMATION_INTERVAL = 0.1
local MESSAGE_ANIMATION_INTERVAL = 0.03
local SHUTTER_ANIMATION = 1
local SHUTTER_ANIMATION_FAST = 0.5
local SHUTTER_ANIMATION_QUICK = 0.1
local SETFADE_ANIMATION = 0.5
local SETFADE_ANIMATION_SUB = 0.8

-- charactor fix position
local CHARA_LEFT_OUT = -300
local CHARA_LEFT = 120
local CHARA_CENTOR = 239
local CHARA_RIGHT = 360
local CHARA_RIGHT_OUT = 780

local CHARA_DIR_LEFT = 1
local CHARA_DIR_RIGHT = 0

-- font size --
local LABEL_NAME_SIZE = 18
local LABEL_SELECT_SIZE = 17
local TEXT_MSG_SIZE = 20

local RESOURCE_WIDTH = 480.0

local res2screen_rate = 1.0
local gcclayer = nil
local back_log = {}
local user_name = ""
local last_name = ""
local first_name = ""
local select_meta = {}
local selected_label = "label1"
local scene_skip_no = 0
local key_wait_flag = false
local message_animation = false
local scripts = nil
local scripts_cursol = 1
local img_data = {}
commands = {}

-- for IF --
local story_flag = ""
local flag_point = 100

local isRunIF = {0}
local isTrueIF = {0}
local IFCommandCount = 0;

-- font color --
local LABEL_C_R = 255
local LABEL_C_G = 255
local LABEL_C_B = 255

-- face --
old_FAC_id = 0
old_FAC_face = 0
old_FAC_time = 0

DRAW_FACE_id = {}

-- vis chara --
old_vis_id = -1;
old_vis_vis = -1;

-- util function --
function sleepFade()
   local start = os.time()
   while os.time() - start < (SETFADE_ANIMATION - SETFADE_ANIMATION_SUB) do end
end

function sleepOneSec()
   local start = os.clock()
	lualog("sleepOneSec: %f", start)
   while os.clock() - start < 1 do end
end

function sleep100ms()
   local start = os.clock()
	lualog("sleep100ms: %f", start)
   while os.clock() - start < 0.1 do end
end

function sleep200ms()
   local start = os.clock()
	lualog("sleep200ms: %f", start)
   while os.clock() - start < 0.2 do end
end

function sleep500ms()
   local start = os.clock()
	lualog("sleep200ms: %f", start)
   while os.clock() - start < 0.5 do end
end



function allHide()
	local nan = gcclayer:getChildByTag(LAYER_NAME)
	local msg = gcclayer:getChildByTag(LAYER_MSG)
		
	nan:setVisible(false)
	msg:setVisible(false)
end

-- event function --
local function onTouchBegan(x, y)
    lualog("onTouchBegan: %0.2f, %0.2f", x, y)
    
    if key_wait_flag then
    	lualog("resume")
    	key_wait_flag = false
    	nextScript()
    elseif message_animation then
    	MessageAnimationSkip(LAYER_MSG);
    end
    
    return true
end

local function onTouchMoved(x, y)
	lualog("onTouchMoved: %0.2f, %0.2f", x, y)
	
	return true
end

local function onTouchEnded(x, y)
	lualog("onTouchEnded: %0.2f, %0.2f", x, y)
	return true
end

local function onTouch(eventType, x, y)
	lualog("onTouch: %s %0.2f, %0.2f", eventType, x, y)
	if eventType == "began" then
		return onTouchBegan(x, y)
	elseif eventType == "moved" then
		return onTouchMoved(x, y)
	else
		return onTouchEnded(x, y)
	end
end

-- setup function --
function storySetupEx(cclayer, last_name_data, first_name_data, love_point, flag)

	lualog( 'call storySetupEx( ' .. love_point .. ', ' .. flag .. ' )' )

    gcclayer = cclayer;
    -- screen size --
    local pDirector = CCDirector:sharedDirector()
    res2screen_rate = pDirector:getWinSize().width / RESOURCE_WIDTH
    pDirector:setContentScaleFactor(RESOURCE_WIDTH / pDirector:getWinSize().width)
	
	-- regist event --
	gcclayer:setTouchEnabled(true)
	gcclayer:registerScriptTouchHandler(onTouch)
	
	-- momery setting --
	collectgarbage("setpause", 100)
	collectgarbage("setstepmul", 5000)
	
	-- user data --
	last_name = last_name_data
	first_name = first_name_data
    
	flag_point = tonumber(love_point)

	story_flag = flag

    return RESOURCE_WIDTH
end

function storySetup(cclayer, name_data)
    gcclayer = cclayer;

    -- screen size --
    local pDirector = CCDirector:sharedDirector()
    res2screen_rate = pDirector:getWinSize().width / RESOURCE_WIDTH
    pDirector:setContentScaleFactor(RESOURCE_WIDTH / pDirector:getWinSize().width)
	
	-- regist event --
	gcclayer:setTouchEnabled(true)
	gcclayer:registerScriptTouchHandler(onTouch)
	
	-- momery setting --
	collectgarbage("setpause", 100)
	collectgarbage("setstepmul", 5000)
	
	-- user data --
	user_name = name_data
    
    return RESOURCE_WIDTH
end

function setupResource(img_json)

	selected_label = "label1"
	scene_skip_no = 0

    -- face init --
    old_FAC_id = 0
    old_FAC_face = 0
    old_FAC_time = 0

	img_data = JSON:decode(img_json)
	local pDirector = CCDirector:sharedDirector()
	local win_size = pDirector:getWinSize()

	-- bg --
    for i=1, MAX_BG, 1 do
		if img_data["bg"..i] ~= "" and img_data["bg"..i] ~= 0 and img_data["bg"..i] ~= nil then
			lualog("bg " .. i .. ": " .. img_data["bg"..i])
			local l = CCSprite:create( IMG_DIR_ADV .. img_data["bg"..i])
			l:setPositionX(win_size.width / 2)
			l:setPositionY(win_size.height / 2)
			l:setTag(IMG_LOW_BG + i)
			l:setVisible(false)
			gcclayer:addChild(l, 0)
		end
	end

	-- fg --
	if img_data["fg"] ~= "" and img_data["fg"] ~= 0 and img_data["fg"] ~= nil then
		lualog("fg: " .. img_data["fg"])
		local l = CCSprite:create( IMG_DIR_ADV .. img_data["fg"])
		l:setPositionX(win_size.width / 2)
		l:setPositionY(win_size.height / 2)
		l:setTag(IMG_LOW_FG)
		l:setVisible(false)
		gcclayer:addChild(l, 10)
	end

	-- chara --
	local ary_face_name = {
		"face_normal_name",
		"face_preasure_name",
		"face_sad_name",
		"face_anger_name",
		"face_surprise_name",
		"face_red_name",
		"face_close_eye_name"
	}


    lualog("==========charactor load==========")
    for i=1, MAX_CHARA, 1 do
    	CHARA_FACE_PARTS[i] = {}
        DRAW_FACE_id[i] = -1
		if img_data["chara"..i] ~= nil then
            local chara_data = img_data["chara"..i]
            lualog("charactor " .. i .. " basename=" .. chara_data["base_name"])

            if chara_data["base_name"] ~= "" and chara_data["base_name"] ~= 0  then
                lualog(IMG_DIR_CHARA .. chara_data["base_name"])
                lualog("face_pos_x:" .. chara_data["sp_face_pos_x"])
                lualog("face_pos_y:" .. chara_data["sp_face_pos_y"])
                
                local face_files = chara_data["face_file"]
--                MAX_CHARA_FACE_PARTS[i] = #face_files

                -- create body --
                local l = CCSprite:create(IMG_DIR_CHARA .. chara_data["base_name"])
                l:setTag(IMG_LOW_CHARA + i)
                l:setPosition(ccp(win_size.width / 2, (win_size.height - 0 * res2screen_rate) / 2))
                l:setVisible(false)
                -- add face --
                local face_x = chara_data["sp_face_pos_x"] * res2screen_rate
                local face_y = l:getContentSize().height - chara_data["sp_face_pos_y"] * res2screen_rate

                for j=0, #face_files-1, 1 do
                	local face_img = table.remove( face_files, 1 )
   
                    lualog("num=%d " .. IMG_DIR_CHARA .. "%s:%d", #face_files, face_img[ "file_name" ], face_img["no"])

                    CHARA_FACE_PARTS[i][j] = face_img["no"]

                    local ll = CCSprite:create(IMG_DIR_CHARA .. face_img[ "file_name" ])
                    ll:setAnchorPoint(ccp(0.0, 1.0))
                    ll:setPosition(ccp(face_x, face_y))
                    ll:setTag( face_img["no"] + FACE_ID_BASE_ADD )
                    ll:setOpacity(0)
                    ll:setVisible(false)
                     l:addChild(ll, 0)
                end


--                for j=1, MAX_CHARA_FACE_PARTS, 1 do
--                    if chara_data[ ary_face_name[j] ] ~= "" and chara_data[ ary_face_name[j] ] ~= 0 and chara_data[ ary_face_name[j] ] ~= nil then
--                        lualog(IMG_DIR_CHARA .. "%s:%d",chara_data[ ary_face_name[j] ], j)
--
--                        local ll = CCSprite:create(IMG_DIR_CHARA .. chara_data[ ary_face_name[j] ])
--                        ll:setAnchorPoint(ccp(0.0, 1.0))
--                        ll:setPosition(ccp(face_x, face_y))
--                        ll:setTag( j - FACE_ID_BASE_ADD )
--                        ll:setOpacity(0)
--                        ll:setVisible(false)
--                        l:addChild(ll, 0)
--
--                    elseif chara_data[ "face_file_" .. (j - 1) ] ~= "" and chara_data[  "face_file_" .. (j - 1) ] ~= 0 and chara_data[  "face_file_" .. (j - 1) ] ~= nil then
--                        lualog(IMG_DIR_CHARA .. "%s:%d",chara_data[ "face_file_" .. (j - 1) ], j - 1)
--
--                        local ll = CCSprite:create(IMG_DIR_CHARA .. chara_data[ "face_file_" .. (j - 1) ])
--                        ll:setAnchorPoint(ccp(0.0, 1.0))
--                        ll:setPosition(ccp(face_x, face_y))
--                        ll:setTag( j - FACE_ID_BASE_ADD )
--                        ll:setOpacity(0)
--                        ll:setVisible(false)
--                        l:addChild(ll, 0)
--                    end
--                end
                
                gcclayer:addChild(l, 1)
            end

		end
	end
    lualog("==========charactor loaded==========")


	--========== load message layer ==========--  
  local layer_msg = CCSprite:create("dummy.png")
  layer_msg:setPosition(ccp(win_size.width / 2, (win_size.height - 476 * res2screen_rate) / 2))
  layer_msg:setVisible(false)
  layer_msg:setTag(LAYER_MSG)
  gcclayer:addChild(layer_msg, 20)

	-- message window --  
	local l = CCSprite:create(IMG_DIR_ETC .. "red_msg.png")

	l:setTag(IMG_MSG)
	layer_msg:addChild(l, 0)

	-- narration window --
	l = CCSprite:create(IMG_DIR_ETC .. "blue.png")

	l:setTag(IMG_NAR)
	layer_msg:addChild(l, 0)
  
  	-- star anime --
	local layer_icon = CCSprite:create(IMG_DIR_ETC .. "icon.png")
	if layer_icon ~= nil then
		local frames = CCArray:create()

		for i=1, STAR_ANIMATION_FRAME, 1 do
		    local frame =  CCSpriteFrame:create(string.format(IMG_DIR_ETC .. "icon.png", i), layer_icon:getTextureRect())
			local offset = frame:getOffset()
			offset.y = offset.y + i - 1
			frame:setOffset( offset )
		    frames:addObject( frame )
		end

		local animation_frames = CCAnimation:createWithSpriteFrames(frames, STAR_ANIMATION_INTERVAL)
		local animate_track = CCAnimate:create(animation_frames)
		local animate_repeator = CCRepeatForever:create(animate_track)
		
		layer_icon:setPosition(ccp(210 * res2screen_rate, -40 * res2screen_rate))
		layer_icon:setTag(IMG_STAR)
		layer_icon:runAction(animate_repeator)
		layer_msg:addChild(layer_icon, 1)
		lualog("IMG_STAR=" .. IMG_STAR)
	end


	--========== load name layer ==========--

  local layer_name = CCSprite:create("dummy.png");
  layer_name:setPosition(ccp((win_size.width - 210 * res2screen_rate) / 2, win_size.height / 2 - 161 * res2screen_rate))
  layer_name:setVisible(false)
  layer_name:setTag(LAYER_NAME)
  gcclayer:addChild(layer_name, 20)

  -- name window --
  l = CCSprite:create(IMG_DIR_ETC .. "red_name.png")
  local name_size = l:boundingBox()
  l:setTag(IMG_NAME)
  layer_name:addChild(l)

  l = CCLabelTTF:create("", "arial", LABEL_NAME_SIZE * res2screen_rate);
  l:setAnchorPoint(ccp(0.0, 0.5))
  l:setPosition(ccp(30 * res2screen_rate - name_size.size.width / 2, 3 * res2screen_rate))
  l:setColor(ccc3(LABEL_C_R,LABEL_C_G,LABEL_C_B))
--  l:setFontFillColor(ccc3(LABEL_C_R,LABEL_C_G,LABEL_C_B), true)
--  l:enableStroke(ccc3(0,0,0), 1.0)
  l:setTag(LABEL_NAME)
  layer_name:addChild(l)
    
--[[
	-- fast button --
	local layer_fast = CCSprite:create("Story/etc/fast.png")
    layer_fast:setPosition(ccp(win_size.width / 2, win_size.height / 2))
    layer_fast:setTag(IMG_FAST)
    layer_fast:setVisible(false)
    gcclayer:addChild(layer_fast)
	
]]	

	-- select button --
	local layer_if = CCSprite:create("dummy.png");
	layer_if:setPosition(ccp((win_size.width) / 2, (win_size.height) / 2))
	layer_if:setVisible(false)
	layer_if:setTag(LAYER_IF)
	gcclayer:addChild(layer_if, 20)

	local layer_shutter = CCSprite:create(IMG_DIR_ETC .. "shutter.png")
--    layer_shutter:setPosition(ccp(0, (win_size.height - 120 * res2screen_rate) / 2))
    layer_shutter:setPosition(ccp(340 * res2screen_rate, win_size.height / 2))
     layer_shutter:setTag(IMG_SHUTTER)
    gcclayer:addChild(layer_shutter, 50)

	-- window frame
	local win_size = pDirector:getWinSize()
	local rect_size = 400
	top_bk_frame = CCLayerColor:create( ccc4( 0, 0, 0, 255 ), win_size.width, rect_size * res2screen_rate )
	top_bk_frame:setPosition( ccp( 0, win_size.height / 2 + 300* res2screen_rate ))
	top_bk_frame:setTag(TOP_BK_FRAME)
	gcclayer:addChild(top_bk_frame, 100)

	bottom_bk_frame = CCLayerColor:create( ccc4( 0, 0, 0, 255 ), win_size.width, rect_size * res2screen_rate )
	bottom_bk_frame:setPosition( ccp( 0, win_size.height / 2 - (300 + rect_size) * res2screen_rate ))
	bottom_bk_frame:setTag(BOTTOM_BK_FRAME)
	gcclayer:addChild(bottom_bk_frame, 100)

end


function startScript(script_json)
	if AUTO_TOUCH_MODE == 1 then
		StartAutoTouch()
	end

	scripts = JSON:decode(script_json)
	scripts_cursol = 0;
	select_meta = {}
	selected_label = "label1"
	key_wait_flag = false
	message_animation = false
	
	nextScript()
end

function nextScript()
	scripts_cursol = scripts_cursol + 1
	local script_str = scripts[scripts_cursol];
	
--	lualog("scripts_cursol = " .. scripts_cursol)
--	lualog("scripts = " .. #scripts)
--	lualog("IFCommandCount = " .. IFCommandCount)
	script_str = string.gsub(script_str, "\n", "\\n");

	local command_str = string.sub(script_str, 1, 3)

--	lualog("   command_str = " .. command_str)

	if IFCommandCount == 0 or command_str == "IF " or command_str == "ELS" or command_str == "END"  then
		lualog(string.gsub(script_str,"%%","%%%%"))
		local cmd = "commands:" .. script_str
		assert(loadstring(cmd))()
	else
		if isRunIF[IFCommandCount] == 1 then
			lualog(string.gsub(script_str,"%%","%%%%"))
			local cmd = "commands:" .. script_str
			assert(loadstring(cmd))()
		else
			nextScript()
		end
	end
end

-- command function --
--============ Name ============--
function commands:NAM(str)
	lualog('NAM:called: ' .. str)
    
    if str == nil then
		str = ""
	end

	local layer = gcclayer:getChildByTag(LAYER_NAME)

	if str == "$OWNER" then
	    layer:setVisible(false)
	    nextScript()
		return
	end 

    local show_str = string.gsub(str, "$LASTNAME", last_name);
    show_str = string.gsub(show_str, "$FIRSTNAME", first_name);
    show_str = string.gsub(show_str, "　", " ");
    show_str = string.gsub(show_str, "  ", " ");
	
	local label = layer:getChildByTag(LABEL_NAME)

    label:setString(show_str)
    layer:setVisible(true)
    
	nextScript()
end


function commands:NAN(str)
	lualog('Name:called')
    
    if str == nil then
		str = ""
	end
    local show_str = string.gsub(str, "$USER", user_name);
    show_str = string.gsub(show_str, "$LASTNAME", last_name);
    show_str = string.gsub(show_str, "$FIRSTNAME", first_name);
	
	local layer = gcclayer:getChildByTag(LAYER_NAME)
	local label = layer:getChildByTag(LABEL_NAME)

    label:setString(show_str)
    
	nextScript()
end

--============ Message ============--
--[[
function message_animation(line1, line2, line3)
	local layer = gcclayer:getChildByTag(LAYER_MSG)
	layer:setVisible(true)

    local animation_delay = 0
	local label1 = layer:getChildByTag(LABEL_MSG_LINE1)
    local label2 = layer:getChildByTag(LABEL_MSG_LINE2)
    local label3 = layer:getChildByTag(LABEL_MSG_LINE3)
	label1:setVisible(false)
    label2:setVisible(false)
    label3:setVisible(false)

    local ary_begin_func = {
        function() gcclayer:getChildByTag(LAYER_MSG):getChildByTag(LABEL_MSG_LINE1):setVisible(true) end,
        function() gcclayer:getChildByTag(LAYER_MSG):getChildByTag(LABEL_MSG_LINE2):setVisible(true) end,
        function() gcclayer:getChildByTag(LAYER_MSG):getChildByTag(LABEL_MSG_LINE3):setVisible(true) end
    }
    
    local ary_label = {
        label1,
        label2,
        label3
    }
    
    local ary_line = {
        line1,
        line2,
        line3
    }

    for i=1, 3, 1 do
        if ary_line[i] ~= nil and ary_line[i] ~= "" then
            ary_label[i]:setString(ary_line[i])

            local texture = ary_label[i]:getTexture()
            local tex_width = texture:getContentSize().width;
            local frame_num = math.ceil(tex_width / (LABEL_MSG_SIZE * res2screen_rate))
            local frames = CCArray:create()

            for j=1, frame_num, 1 do
                frames:addObject(
                    CCSpriteFrame:createWithTexture(texture, CCRectMake(0, 0, math.min(LABEL_MSG_SIZE * res2screen_rate * j, tex_width) , LABEL_MSG_SIZE * res2screen_rate))
                )
            end
        
            local animation_frames = CCAnimation:createWithSpriteFrames(frames, MESSAGE_ANIMATION_INTERVAL)
            local tracks = CCArray:create()

            if i > 1 then
                tracks:addObject( CCDelayTime:create(animation_delay) )
            end
            
            tracks:addObject( CCCallFunc:create(ary_begin_func[i]) )
            tracks:addObject( CCAnimate:create(animation_frames) )
            local seq = CCSequence:create(tracks)
            seq:setTag(OBJ_ANIMATION_MESSAGE + i)
            ary_label[i]:runAction( seq )
        
            animation_delay = animation_delay + frame_num * MESSAGE_ANIMATION_INTERVAL
        end
    end
    
    local task = CCArray:create() 
    task:addObject( CCDelayTime:create(animation_delay) )
	task:addObject( CCCallFunc:create(nextScript) )
	local runing_message = CCSequence:create(task)
	runing_message:setTag(OBJ_ANIMATION_MESSAGE)
	gcclayer:runAction( runing_message )
end
]]

function messageAnimationEnd()
	lualog('messageAnimationEnd')
	
	if message_animation then
		gcclayer:getChildByTag(LAYER_MSG):getChildByTag(IMG_STAR):setVisible(true);
		gcclayer:runAction( CCCallFunc:create(nextScript) )
	end
	
	message_animation = false
end

function commands:MES(line1, line2, line3)
	lualog('Message:called')
	
--    gcclayer:getChildByTag(LAYER_NAME):setVisible(true)
	
	local layer = gcclayer:getChildByTag(LAYER_MSG)
	layer:setVisible(true)
	
	local img = layer:getChildByTag(IMG_MSG)
	img:setVisible(true)
	
	img = layer:getChildByTag(IMG_NAR)
	img:setVisible(false)
	
	if line1 == nil then
		line1 = ""
	end
    local show_str = string.gsub(line1, "$USER", user_name);
    show_str = string.gsub(show_str, "$LASTNAME", last_name);
    show_str = string.gsub(show_str, "$FIRSTNAME", first_name);
	
	layer:getChildByTag(IMG_STAR):setVisible(false);
	--MessageAnimationStart(LAYER_MSG, show_str,TEXT_MSG_SIZE,0,0,0)
	MessageAnimationStart(LAYER_MSG, show_str)
	message_animation = true
end

--============ Narration ============--
function commands:NAR(line1)
    commands:NAR(line1, "", "")
end

function commands:NAR(line1, line2, line3)
	lualog('Narration:called')
    
    gcclayer:getChildByTag(LAYER_NAME):setVisible(false)
    
	local layer = gcclayer:getChildByTag(LAYER_MSG)
	layer:setVisible(true)
	
	local img = layer:getChildByTag(IMG_NAR)
	img:setVisible(true)
	
	img = layer:getChildByTag(IMG_MSG)
	img:setVisible(false)
	
	if line1 == nil then
		line1 = ""
	end
    local show_str = string.gsub(line1, "$USER", user_name);
    show_str = string.gsub(show_str, "$LASTNAME", last_name);
    show_str = string.gsub(show_str, "$FIRSTNAME", first_name);
	
	layer:getChildByTag(IMG_STAR):setVisible(false);
	--MessageAnimationStart(LAYER_MSG, show_str,TEXT_MSG_SIZE,0,0,0)
	MessageAnimationStart(LAYER_MSG, show_str)
	message_animation = true
end

--============ DrawChara ============--
function commands:DRA(id, face, pos, dir)
	lualog('DrawChara:called')
	id = tonumber(id)
	face = tonumber(face)
	pos = tonumber(pos)
	dir = tonumber(dir)
    
	local body_l = gcclayer:getChildByTag(IMG_LOW_CHARA + id)

    if body_l == nil then
        gcclayer:runAction( CCCallFunc:create(nextScript) )
        return
    end

	local face_l = body_l:getChildByTag( FACE_ID_BASE_ADD + face)

    if face_l == nil then
        gcclayer:runAction( CCCallFunc:create(nextScript) )
        return
    end

	face_l:setOpacity(255)
	face_l:setVisible(true)
	
	for j = 0, #CHARA_FACE_PARTS[id], 1 do
		if CHARA_FACE_PARTS[id][j] ~= face then
		    face_l = body_l:getChildByTag(FACE_ID_BASE_ADD + CHARA_FACE_PARTS[id][j])
		    if face_l ~= nil then
		        face_l:setOpacity(0)
		        face_l:setVisible(false)
		    end
		end
	end
	
	if pos == 0 then
        moved_pos = CHARA_LEFT_OUT * res2screen_rate
    end
    if pos == 1 then
        moved_pos = CHARA_LEFT * res2screen_rate
    end
    if pos == 2 then
        moved_pos = CHARA_CENTOR * res2screen_rate
    end
    if pos == 3 then
        moved_pos = CHARA_RIGHT * res2screen_rate
    end
    if pos == 4 then
        moved_pos = CHARA_RIGHT_OUT * res2screen_rate
    end
    body_l:setPositionX(moved_pos)
    
    local face_pos_x = img_data["chara"..id]["sp_face_pos_x"]
    if dir == CHARA_DIR_RIGHT then
        body_l:runAction( CCFlipX:create( true ) );
		for j = 0, #CHARA_FACE_PARTS[id], 1 do
		    face = body_l:getChildByTag(FACE_ID_BASE_ADD + CHARA_FACE_PARTS[id][j])
            if face ~= nil then
              face:setAnchorPoint(ccp(1.0, 1.0))
              face:setPositionX( body_l:getContentSize().width - face_pos_x * res2screen_rate )
              face:runAction( CCFlipX:create( true ) );
            end
        end
    else
        body_l:runAction( CCFlipX:create( false ) );
		for j = 0, #CHARA_FACE_PARTS[id], 1 do
		    face = body_l:getChildByTag(FACE_ID_BASE_ADD + CHARA_FACE_PARTS[id][j])
            if face ~= nil then
            	face:setPositionX( face_pos_x * res2screen_rate )
	            face:setAnchorPoint(ccp(0.0, 1.0))
	            face:runAction( CCFlipX:create( false ) );
	        end
	    end
    end
    
    body_l:setVisible( false )
    body_l:setOpacity(255)
    
    gcclayer:runAction( CCCallFunc:create(nextScript) )
end

--============ DrawFace ============--
function commands:FAC(id, face, time)
	if time == nil then
		time = 0
	end
	lualog('DrawFace:called' .. " id=" .. id .. " face=" .. face .. " time=" .. time)
    lualog('  ' .. " old_id=" .. old_FAC_id .. " old_face=" .. old_FAC_face .. " old_time=" .. old_FAC_time)
	id = tonumber(id)
	face = tonumber(face)
	time = tonumber(time)
	DRAW_FACE_id[id] = face
--[[ 
    if old_FAC_id == id and old_FAC_face == face and old_FAC_time == time then
        local body_l = gcclayer:getChildByTag(IMG_LOW_CHARA + id)
        local face_l = body_l:getChildByTag(FACE_ID_BASE_ADD + face)
        face_l:setOpacity(255)
        gcclayer:runAction( CCCallFunc:create(nextScript) )
        return
    end

    if time ~= -1 then
        old_FAC_id = id
        old_FAC_face = face
        old_FAC_time = time
        time = 0
    end
]]--
    if time ~= -1 then
        time = 0
    end

    if time == 0 then
        local body_l = gcclayer:getChildByTag(IMG_LOW_CHARA + id)
        local face_l = body_l:getChildByTag(FACE_ID_BASE_ADD + face)

--[[        
        if old_vis_id ~= -1 then
        	commands:VIS_LOCAL(old_vis_id, 1)
        else
	        body_l:setOpacity(255)
		    body_l:setVisible(true)
        end
]]--
        face_l:setOpacity(255)
        face_l:setVisible(true)

		for j = 0, #CHARA_FACE_PARTS[id], 1 do
--			    lualog("#CHARA_FACE_PARTS[id] = " .. #CHARA_FACE_PARTS[id] ..  " CHARA_FACE_PARTS[" .. id .. "][" .. j .. "] = " .. CHARA_FACE_PARTS[id][j]);
			if CHARA_FACE_PARTS[id][j] ~= face then
			    face_l = body_l:getChildByTag(FACE_ID_BASE_ADD + CHARA_FACE_PARTS[id][j])
                if face_l ~= nil then
                    face_l:setOpacity(0)
                    face_l:setVisible(false)
                end
            end
        end
        gcclayer:runAction( CCCallFunc:create(nextScript) )
        
    else
        local body_l = gcclayer:getChildByTag(IMG_LOW_CHARA + id)
        local face_l = body_l:getChildByTag(FACE_ID_BASE_ADD + face)
        
        function create_end_func(obj)
          local obj = obj
          return function()
              local body_ll = gcclayer:getChildByTag(IMG_LOW_CHARA + obj[1])
              local face_ll = body_ll:getChildByTag(FACE_ID_BASE_ADD + obj[2])
              body_ll:reorderChild(face_ll, 0)
            
              commands:FAC(obj[1], obj[2], -1)
              obj = nil
          end
        end

        body_l:reorderChild(face_l,1)
        face_l:setVisible(true)

        local tracks = CCArray:create()
        tracks:addObject( CCFadeIn:create(time/10) )
        tracks:addObject( CCCallFunc:create( create_end_func({id, face}) ) )
        face_l:runAction( CCSequence:create(tracks) )
    end

end

--============ DirectionChara ============--
function commands:DIR(id, dir)
	lualog('DirectionChara:called')
	id = tonumber(id)
	dir = tonumber(dir)
    
    local face_pos_x = img_data["chara"..id]["sp_face_pos_x"]
    local chara = gcclayer:getChildByTag(IMG_LOW_CHARA + id)
    if dir == CHARA_DIR_RIGHT then
        chara:runAction( CCFlipX:create( true ) );
		for j = 0, #CHARA_FACE_PARTS[id], 1 do
		    face = chara:getChildByTag(FACE_ID_BASE_ADD + CHARA_FACE_PARTS[id][j])
            if face ~= nil then
              face:setAnchorPoint(ccp(1.0, 1.0))
              face:setPositionX( chara:getContentSize().width - face_pos_x * res2screen_rate )
              face:runAction( CCFlipX:create( true ) );
            end
        end
    else
        chara:runAction( CCFlipX:create( false ) );
		for j = 0, #CHARA_FACE_PARTS[id], 1 do
		    face = chara:getChildByTag(FACE_ID_BASE_ADD + CHARA_FACE_PARTS[id][j])
            if face ~= nil then
              face:setPositionX( face_pos_x * res2screen_rate )
              face:setAnchorPoint(ccp(0.0, 1.0))
              face:runAction( CCFlipX:create( false ) );
            end
        end
    end
    
    gcclayer:runAction( CCCallFunc:create(nextScript) )
end

--============ VisibleChara ============--
function commands:VIS(id, vis)
	lualog('VisibleChara:called' .. " id=" .. id .. " vis=" .. vis)
	id = tonumber(id)
	vis = tonumber(vis)

    local chara = gcclayer:getChildByTag(IMG_LOW_CHARA + id)
    if chara == nil then
        gcclayer:runAction( CCCallFunc:create(nextScript) )
        return
    end
--[[
    if id == old_vis_id and vis == old_vis_vis then
    	chara:setVisible( (vis == 1) )
        chara:setOpacity(255)
        gcclayer:runAction( CCCallFunc:create(nextScript) )
        return
    end

    if vis == 1 then
		old_vis_id = id;
	else
		old_vis_id = -1;
    end
    old_vis_vis = vis;
]]--

    chara:setVisible( (vis == 1) )
    chara:setOpacity(255)
    
    gcclayer:runAction( CCCallFunc:create(nextScript) )
end

function commands:VIS_LOCAL(id, vis)
	lualog('VisibleChara(local):called' .. " id=" .. id .. " vis=" .. vis)
	id = tonumber(id)
	vis = tonumber(vis)

    local chara = gcclayer:getChildByTag(IMG_LOW_CHARA + id)
    if chara == nil then
        return
    end
--[[
    if id == old_vis_id and vis == old_vis_vis then
    	chara:setVisible( (vis == 1) )
        chara:setOpacity(255)
        return
    end

    if vis == 1 then
		old_vis_id = id;
	else
		old_vis_id = -1;
    end
    old_vis_vis = vis;
]]--
    chara:setVisible( (vis == 1) )
    chara:setOpacity(255)
end

--============ MoveChara ============--
function commands:MOV(id, pos, time)
	lualog('MoveChara:called')
	id = tonumber(id)
	pos = tonumber(pos)
	time = tonumber(time)

	if time < 0 then
		time = time * -1
	end

    local chara = gcclayer:getChildByTag(IMG_LOW_CHARA + id)
    local moved_pos = nil
    
	if pos == CHARA_POS_DIR_OVER_LEFT then
        moved_pos = CHARA_LEFT_OUT * res2screen_rate
    end
    if pos == CHARA_POS_DIR_LEFT then
        moved_pos = CHARA_LEFT * res2screen_rate
    end
    if pos == CHARA_POS_DIR_CENTER then
        moved_pos = CHARA_CENTOR * res2screen_rate
    end
    if pos == CHARA_POS_DIR_RIGHT then
        moved_pos = CHARA_RIGHT * res2screen_rate
    end
    if pos == CHARA_POS_DIR_OVER_RIGHT then
        moved_pos = CHARA_RIGHT_OUT * res2screen_rate
    end
    
    if time == 0 then
        chara:setPositionX(moved_pos)
        gcclayer:runAction( CCCallFunc:create(nextScript) )
    else
        local pos_y = chara:getPositionY()
        local tracks = CCArray:create()
        tracks:addObject( CCMoveTo:create( time/10, ccp(moved_pos, pos_y) ) )
        tracks:addObject( CCCallFunc:create(nextScript) )
        chara:runAction( CCSequence:create(tracks) )
    end
end

local old_BKG_pos = 0;
local old_BKG_id = 0;

--============ DrawBack ============--
function commands:BKG(id, pos)
	lualog('DrawBack:called')
	if id == nil then
		id = 0
	end
	if pos == nil then
		pos = 0
	end
	
	id = tonumber(id)
	pos = tonumber(pos)
	old_BKG_pos = pos
	old_BKG_id = id

	local pDirector = CCDirector:sharedDirector()
	local win_size = pDirector:getWinSize()

	local l = gcclayer:getChildByTag(IMG_LOW_BG + id)
	if l ~= nil then

		local h = l:boundingBox().size.height * ( 1 / res2screen_rate )
		local w = l:boundingBox().size.width * ( 1 / res2screen_rate )
		lualog( ' w: ' .. w .. ' h: ' .. h )
		if w > 480 or h > 640 then
			if pos == 1 then		-- ã
				l:setPositionY(win_size.height / 2 - 300 * res2screen_rate)
				l:setPositionX(win_size.width / 2)

			elseif pos == 2 then	-- ‰E
				l:setPositionX(win_size.width / 2 - 240 * res2screen_rate)
				l:setPositionY(win_size.height / 2)

			elseif pos == 3 then	-- ‰º
				l:setPositionY(win_size.height / 2 + 300 * res2screen_rate)
				l:setPositionX(win_size.width / 2)

			elseif pos == 4 then	-- ¶
				l:setPositionX(win_size.width / 2 + 240 * res2screen_rate)
				l:setPositionY(win_size.height / 2)
			end
		else
			l:setPositionX(win_size.width / 2)
			l:setPositionY(win_size.height / 2)
		end

    	l:setVisible(true)
    end

    for i=1, MAX_BG, 1 do
        if i ~= id then
            l = gcclayer:getChildByTag(IMG_LOW_BG + i)
            if l ~= nil then
            	l:setVisible(false)
            end
        end
    end
    
    nextScript()
end

--============ Wait ============--
function commands:WAI(time)
	lualog('Wait:called')
	
	local tracks = CCArray:create()
	tracks:addObject( CCDelayTime:create(time/10) )
	tracks:addObject( CCCallFunc:create(nextScript) )
	gcclayer:runAction( CCSequence:create(tracks) )
end

--============ Shake ============--
function commands:SHA()
	lualog('Shake:called')
	gcclayer:runAction( CCCallFunc:create(nextScript) )
end

-- StartVibrate --

-- StopVibrate --

-- PlaySound --
function commands:PLA(id)
	gcclayer:runAction( CCCallFunc:create(nextScript) )
end

-- StopSound --
function commands:STO(id)
	gcclayer:runAction( CCCallFunc:create(nextScript) )
end

-- shutter effect --
function shutterOn()
	lualog('shutterOn:called')
	
	local shutter = gcclayer:getChildByTag(IMG_SHUTTER)
	shutter:setPositionX(340 * res2screen_rate)
end

function shutterOff()
	lualog('shutterOff:called')
	local shutter = gcclayer:getChildByTag(IMG_SHUTTER)
	shutter:setPositionX((340 - 680) * res2screen_rate )
end

--============ ShutterIn ============--
function commands:SIN(effect, red, green, blue)
	lualog('SIN:called')
	effect = tonumber(effect)
	
	local shutter = gcclayer:getChildByTag(IMG_SHUTTER)
	local tracks = CCArray:create()
	
	if effect == 1 then
		shutter:setPositionX(340 * res2screen_rate);
		shutter:setScaleX(1)
		opacity = shutter:getOpacity()
		if opacity == 0 then
		    tracks:addObject( CCFadeIn:create( SHUTTER_ANIMATION_QUICK ) )
		end
	end
	
	if effect == 2 then
		shutter:setPositionX(340 * res2screen_rate);
		shutter:setScaleX(1)
		opacity = shutter:getOpacity()
		if opacity == 0 then
		    tracks:addObject( CCFadeIn:create( SHUTTER_ANIMATION ) )
		end
	end
	
	if effect == 3 then
		opacity = shutter:getOpacity()
		if opacity == 0 then
			local moved_x = 140 * res2screen_rate
			local moved_y = shutter:getPositionY()
			shutter:setPositionX((140 + 680) * res2screen_rate)
			shutter:setScaleX(-1)
			shutter:setOpacity(255)
			tracks:addObject( CCMoveTo:create( SHUTTER_ANIMATION, ccp( moved_x, moved_y)) )
		end
	end
	
	if effect == 4 then
		opacity = shutter:getOpacity()
		if opacity == 0 then
			local moved_x = 340 * res2screen_rate
			local moved_y = shutter:getPositionY()		
			shutter:setPositionX((340 - 680) * res2screen_rate)
			shutter:setScaleX(1)
			shutter:setOpacity(255)
			tracks:addObject( CCMoveTo:create( SHUTTER_ANIMATION, ccp( moved_x, moved_y)) )
		end
	end

	if effect == 5 then
		shutter:setPositionX(340 * res2screen_rate);
		shutter:setScaleX(1)
	    tracks:addObject( CCFadeIn:create( SHUTTER_ANIMATION_QUICK ) )
	    tracks:addObject( CCFadeOut:create( SHUTTER_ANIMATION_QUICK ) )
	    tracks:addObject( CCFadeIn:create( SHUTTER_ANIMATION_QUICK ) )
	    tracks:addObject( CCFadeOut:create( SHUTTER_ANIMATION_QUICK ) )
	    tracks:addObject( CCFadeIn:create( SHUTTER_ANIMATION_QUICK ) )

	end
	
	tracks:addObject( CCCallFunc:create(allHide) )
	tracks:addObject( CCCallFunc:create(nextScript) )
	shutter:runAction( CCSequence:create(tracks) )
end


--============ ShutterOut ============--
function commands:SOU(effect, red, green, blue)
	lualog('SOU:called')
	effect = tonumber(effect)
	
	local shutter = gcclayer:getChildByTag(IMG_SHUTTER)
	local tracks = CCArray:create()
	
	if effect == 1 then
		shutter:setPositionX(340 * res2screen_rate);
		shutter:setScaleX(1)
		opacity = shutter:getOpacity()
		if opacity ~= 0 then
		    tracks:addObject( CCFadeOut:create( SHUTTER_ANIMATION_QUICK ) )
		end
	end
	
	if effect == 2 then
		shutter:setPositionX(340 * res2screen_rate);
		shutter:setScaleX(1)
		opacity = shutter:getOpacity()
		if opacity ~= 0 then
		    tracks:addObject( CCFadeOut:create( SHUTTER_ANIMATION ) )
		end
	end
	
	if effect == 3 then
		opacity = shutter:getOpacity()
		if opacity ~= 0 then
			local moved_x = (140 + 680) * res2screen_rate
			local moved_y = shutter:getPositionY()
			shutter:setPositionX(140 * res2screen_rate)
			shutter:setScaleX(-1)
			shutter:setOpacity(255)
			tracks:addObject( CCMoveTo:create( SHUTTER_ANIMATION, ccp( moved_x, moved_y)) )
		end
	end
	
	if effect == 4 then
		opacity = shutter:getOpacity()
		if opacity ~= 0 then
			local moved_x = (340 - 680) * res2screen_rate
			local moved_y = shutter:getPositionY()		
			shutter:setPositionX(340 * res2screen_rate)
			shutter:setScaleX(1)
			shutter:setOpacity(255)
			tracks:addObject( CCMoveTo:create( SHUTTER_ANIMATION, ccp( moved_x, moved_y)) )
		end
	end

	if effect == 5 then
		shutter:setPositionX(340 * res2screen_rate);
		shutter:setScaleX(1)
	    tracks:addObject( CCFadeOut:create( SHUTTER_ANIMATION_QUICK ) )
	    tracks:addObject( CCFadeIn:create( SHUTTER_ANIMATION_QUICK ) )
	    tracks:addObject( CCFadeOut:create( SHUTTER_ANIMATION_QUICK ) )
	    tracks:addObject( CCFadeIn:create( SHUTTER_ANIMATION_QUICK ) )
	    tracks:addObject( CCFadeOut:create( SHUTTER_ANIMATION_QUICK ) )
	end
	
	tracks:addObject( CCCallFunc:create(nextScript) )
	shutter:runAction( CCSequence:create(tracks) )
end



--============ OffWindow ============--
function commands:OWI()
	lualog('OffWindow:called')
	
	local n = gcclayer:getChildByTag(LAYER_NAME)
	local m = gcclayer:getChildByTag(LAYER_MSG)
    
	n:setVisible(false)
	m:setVisible(false)
	
	nextScript()
end

--============ SetFade ============--
function commands:SFA(target, id, fadeValue)
    lualog('SetFade:called target=' .. target .. ' id=' .. id .. ' fadeValue=' .. fadeValue)
	
    target = tonumber(target)
    id = tonumber(id)
    fadeValue = tonumber(fadeValue)

	if target == 0 then
		--window
    	lualog('SetFade:window')
		local nan = gcclayer:getChildByTag(LAYER_NAME)
		local msg = gcclayer:getChildByTag(LAYER_MSG)
		
		if fadeValue == -1 then
			--fade out
			nan:setVisible(false)
			msg:setVisible(false)
			
		elseif fadeValue == -2 then
			--fade in
			nan:setVisible(true)
			msg:setVisible(true)
			
		else
			--visibility 
			local isVisible = (fadeValue ~= 0)
			
			nan:setVisible(isVisible)
			msg:setVisible(isVisible)
		end
        nextScript()
		
	elseif target == 1 then
		--character
		lualog('SetFade:character')
		local l = gcclayer:getChildByTag( IMG_LOW_CHARA + id )
		lualog('  -- 1')
		old_vis_id = -1
		if fadeValue == -1 then
			--fade out
            lualog('SetFade:fade out')
		    
			for j = 0, #CHARA_FACE_PARTS[id], 1 do
			    ll = l:getChildByTag(FACE_ID_BASE_ADD + CHARA_FACE_PARTS[id][j])
		    	if ll ~= nil then
		    		local lltracks = CCArray:create()
					lltracks:addObject( CCFadeOut:create( SETFADE_ANIMATION ) )
--					lltracks:addObject( CCFadeOut:create( SETFADE_ANIMATION_SUB ) )
		    		ll:runAction( CCSequence:create(lltracks) )
		    	end
		    end
		    
            local tracks = CCArray:create()
            tracks:addObject( CCFadeOut:create( SETFADE_ANIMATION ) )
            tracks:addObject( CCCallFunc:create(nextScript) )
            l:runAction( CCSequence:create(tracks) )
			
		elseif fadeValue == -2 then
			--fade in
            lualog('SetFade:fade in')
			
			for j = 0, #CHARA_FACE_PARTS[id], 1 do
			    ll = l:getChildByTag(FACE_ID_BASE_ADD + CHARA_FACE_PARTS[id][j])
		    	if ll ~= nil then
		    		local lltracks = CCArray:create()
					lltracks:addObject( CCFadeIn:create( SETFADE_ANIMATION ) )
		    		ll:runAction( CCSequence:create(lltracks) )
		    	end
		    end

            local tracks = CCArray:create()
            tracks:addObject( CCFadeIn:create( SETFADE_ANIMATION ) )
--            tracks:addObject( CCFadeIn:create( SETFADE_ANIMATION_SUB ) )
--            tracks:addObject( CCCallFunc:create(sleepFade) )
            tracks:addObject( CCCallFunc:create(nextScript) )
            l:setVisible(true)
            l:runAction( CCSequence:create(tracks) )

		else
			--visibility
			if fadeValue == 0 then
				l:setVisible(false)
				l:setOpacity(0)
			else
				l:setVisible(true)
				l:setOpacity(255)
			end
            nextScript()
		end
		
	elseif target == 2 then
		--calendar
        lualog('SetFade:calendar')
        nextScript()
    else
        lualog('SetFade:other')
        nextScript()

	end
    lualog('SetFade:end')
end

--============ KeyWait ============--
function commands:KWA()
	lualog("KeyWait")
	
	key_wait_flag = true
end

--============ end ============--
function commands:EEN( next_label )
	lualog("end: next_label=" .. next_label .. " selected_label=" .. selected_label )
	
	if next_label ~= nil and next_label ~= "NULL" then
		selected_label = next_label
	end

	local l
	
	for i=1, MAX_BG, 1 do
		if gcclayer:getChildByTag(IMG_LOW_BG + i) ~= nil then
			gcclayer:getChildByTag(IMG_LOW_BG + i):setVisible(false)
			gcclayer:removeChildByTag(IMG_LOW_BG + i, true)
		end
	end
	for i=1, MAX_CHARA, 1 do
		local chara = gcclayer:getChildByTag(IMG_LOW_CHARA + i)
		if chara ~= nil then
			chara:setVisible(false)
			chara:removeAllChildrenWithCleanup(true)
			chara:removeFromParentAndCleanup(true)
		end
	end

	if gcclayer:getChildByTag(IMG_LOW_FG) ~= nil then
		gcclayer:getChildByTag(IMG_LOW_FG):setVisible(false)
		gcclayer:removeChildByTag(IMG_LOW_FG, true)
	end
	
	l = gcclayer:getChildByTag(LAYER_MSG)
	if l ~= nil then
		l:removeAllChildrenWithCleanup(true)
		l:removeFromParentAndCleanup(true)
	end
	
	l = gcclayer:getChildByTag(LAYER_NAME)
	if l ~= nil then
		l:removeAllChildrenWithCleanup(true)
		l:removeFromParentAndCleanup(true)
	end
	
	if gcclayer:getChildByTag(IMG_FAST) ~= nil then
		gcclayer:removeChildByTag(IMG_FAST, true)
	end
	if gcclayer:getChildByTag(IMG_SHUTTER) ~= nil then
		gcclayer:removeChildByTag(IMG_SHUTTER, true)
	end
	l = gcclayer:getChildByTag(LAYER_IF)
	if l ~= nil then
		l:removeAllChildrenWithCleanup(true)
		l:removeFromParentAndCleanup(true)
	end

	if gcclayer:getChildByTag(TOP_BK_FRAME) ~= nil then
		gcclayer:removeChildByTag(TOP_BK_FRAME, true)
	end

	if gcclayer:getChildByTag(BOTTOM_BK_FRAME) ~= nil then
		gcclayer:removeChildByTag(BOTTOM_BK_FRAME, true)
	end

	if AUTO_TOUCH_MODE == 1 then
		StopAutoTouch()
	end

	EndScript(selected_label, scene_skip_no, story_flag)
end

--============ if attribute ============--
function btnIfCallback(btnId)
	if select_meta[btnId].attr and selected_label == "label1" then
		selected_label = select_meta[btnId].label
		lualog("btnIfCallback:" .. selected_label)
		nextScript()
	end
end

function commands:IFA(...)
	lualog('if attribute:called')
	
	local args = { ... }
	local layer = gcclayer:getChildByTag(LAYER_IF)
	layer:setVisible(false)

	for k, v in pairs(args) do
		select_meta[k] = {}
		select_meta[k].attr = (tonumber(v) == 1)
	end
		
	nextScript()
end

function commands:IFN(...)
	lualog('if name:called')
	local args = { ... }
	local layer = gcclayer:getChildByTag(LAYER_IF)
	
	local height = 300
	local interval = height / (#args + 1)
	local harf_height = height / 2
	local getIfButtonCallback = function(v)
		local id = v
		return function()
			btnIfCallback(id);
		end
	end

	for k, v in pairs(args) do
		-- if button --
		local pos_y = -(interval * k - harf_height) * res2screen_rate
		local img = CCMenuItemImage:create(IMG_DIR_ETC .. "if.png", IMG_DIR_ETC .. "if.png")
		img:setOpacity(select_meta[k].attr and 255 or 120)
		img:registerScriptTapHandler(getIfButtonCallback(k))
		
		local label = CCLabelTTF:create("", "arial", LABEL_SELECT_SIZE * res2screen_rate);
		label:setColor(ccc3(43,32,0))
		label:setOpacity(select_meta[k].attr and 255 or 120)
		label:setPosition(ccp(20 * res2screen_rate, img:getContentSize().height / 2))
		label:setAnchorPoint(ccp(0.0, 0.5))
		label:setString(v)
		img:addChild(label)
		
		local menu = CCMenu:createWithItem(img)
		menu:setPosition(ccp(0, pos_y))
		menu:setTag(k)
		layer:addChild(menu)
		
		select_meta[k].name = v
	end

	nextScript()
end

function commands:IFE(...)
	nextScript()
end

function commands:IFT(...)
	lualog('if transfer:called')
	local args = { ... }
	
	for k, v in pairs(args) do
		select_meta[k].label = v
	end
	
	nextScript()
end

function commands:IFS()
	lualog('if transfer:called')
	
	l = gcclayer:getChildByTag(LAYER_IF)
	l:setVisible(true)
	--nextScript()
end

-- unused command --

-- DelItem --

-- DelInterior --

-- DelAbility --

-- GetItem --

-- GetInterior --

-- GetAbility --

-- GetStill --

-- ChangeAdvTime --

-- ChangeGrowTime --

-- ChangeLove --

-- If --
local function IF(flag, love_higher, love_lower, p_id, p_higher, p_lower, clear_chara_id, day_higher, day_lower)
	lualog("If")
	local result = true;
	
	return result
end

function commands:IF( flag, dmy, high, low )
	IFCommandCount = IFCommandCount + 1;

	if flag ~= nil then
		lualog('called IF( ' .. flag .. ' ) CommandCount = ' .. IFCommandCount)
	end

	if  flag ~= nil and high ~= nil then
		lualog('called IF( ' .. flag .. ', ' .. high .. ' ) CommandCount = ' .. IFCommandCount)
	end

	if flag ~= nil and high ~= nil and low ~= nil then
		lualog('called IF( ' .. flag .. ', ' .. high .. ', ' .. low .. ' ) CommandCount = ' .. IFCommandCount)
	end

	for i = 1, IFCommandCount - 1, 1 do
		if isTrueIF[ i ] == 1 then
			lualog('   ----- IF : skip IFCommandCount = ' .. IFCommandCount)
			isRunIF[ IFCommandCount ] = 0
			nextScript()
			return
		end
	end

	if flag ~= nil and flag ~= ""  and story_flag == string.sub(flag, 1, 5) then
		isTrueIF[ IFCommandCount ] = 1
		isRunIF[ IFCommandCount ] = 1
	elseif high ~= nil and high ~= "" and flag_point >= tonumber(high) then
		isTrueIF[ IFCommandCount ] = 1
		isRunIF[ IFCommandCount ] = 1
	elseif high ~= nil and high ~= "" and low ~= nil and low ~= "" and flag_point <= tonumber(high) and flag_point >= tonumber(low) then
		isTrueIF[ IFCommandCount ] = 1
		isRunIF[ IFCommandCount ] = 1
	else
		isTrueIF[ IFCommandCount ] = 0
		isRunIF[ IFCommandCount ] = 0
	end

	nextScript()
end

function commands:ELS()
	lualog('ELS:called IFCommandCount = ' .. IFCommandCount)

	for i = 1, IFCommandCount - 1, 1 do
		if isTrueIF[ i ] == 1 then
			lualog('   ----- ELS: skip IFCommandCount = ' .. IFCommandCount)
			isRunIF[ IFCommandCount ] = 0
			nextScript()
			return
		end
	end

	if isTrueIF[ IFCommandCount ] == 0 then
		isRunIF[ IFCommandCount ] = 1
	else
		isRunIF[ IFCommandCount ] = 0
	end
	nextScript()
end

function commands:END()
	lualog('END:called IFCommandCount = ' .. IFCommandCount)
	isTrueIF[ IFCommandCount ] = 0
	isRunIF[ IFCommandCount ] = 0

	IFCommandCount = IFCommandCount - 1;
		
	nextScript()
end


-- OffCalendar --


-- POS --
function commands:POS( id, pos )

	lualog('POS:called')
	id = tonumber(id)
	pos = tonumber(pos)
    
	local body_l = gcclayer:getChildByTag(IMG_LOW_CHARA + id)

    if body_l == nil then
        gcclayer:runAction( CCCallFunc:create(nextScript) )
        return
    end

	if pos == CHARA_POS_DIR_OVER_LEFT then
        moved_pos = CHARA_LEFT_OUT * res2screen_rate
    end
    if pos == CHARA_POS_DIR_LEFT then
        moved_pos = CHARA_LEFT * res2screen_rate
    end
    if pos == CHARA_POS_DIR_CENTER then
        moved_pos = CHARA_CENTOR * res2screen_rate
    end
    if pos == CHARA_POS_DIR_RIGHT then
        moved_pos = CHARA_RIGHT * res2screen_rate
    end
    if pos == CHARA_POS_DIR_OVER_RIGHT then
        moved_pos = CHARA_RIGHT_OUT * res2screen_rate
    end
    body_l:setPositionX(moved_pos)
    
    local face_pos_x = img_data["chara"..id]["sp_face_pos_x"]
    if dir == CHARA_DIR_RIGHT then
        body_l:runAction( CCFlipX:create( true ) );
		for j = 0, #CHARA_FACE_PARTS[id], 1 do
		    face = body_l:getChildByTag(FACE_ID_BASE_ADD + CHARA_FACE_PARTS[id][j])
            if face ~= nil then
	            face:setAnchorPoint(ccp(1.0, 1.0))
            	face:setPositionX( body_l:getContentSize().width - face_pos_x * res2screen_rate )
	            face:runAction( CCFlipX:create( true ) );
	        end
	    end
    else
        body_l:runAction( CCFlipX:create( false ) );
		for j = 0, #CHARA_FACE_PARTS[id], 1 do
		    face = body_l:getChildByTag(FACE_ID_BASE_ADD + CHARA_FACE_PARTS[id][j])
            if face ~= nil then
            	face:setPositionX( face_pos_x * res2screen_rate )
            	face:setAnchorPoint(ccp(0.0, 1.0))
	        	face:runAction( CCFlipX:create( false ) );
            end
	    end
    end
    
    body_l:setVisible( false )
    body_l:setOpacity(255)
    
    gcclayer:runAction( CCCallFunc:create(nextScript) )
end

-- SetFlag --

-- EDS --
function commands:EDS( id )
	-- ‚È‚É‚·‚é‚©‚í‚©‚ç‚ñ‚Ì‚Å”ò‚Î‚·
	nextScript()
end

-- CLO --
function commands:CLO()
	nextScript()
end

-- CCH --
function commands:CCH()
	nextScript()
end

-- CCR --
function commands:CCR()
	nextScript()
end

-- GML --
function commands:GML()
	nextScript()
end


-- GPT --
function commands:GPT()
	nextScript()
end

-- DIT --
function commands:DIT()
	nextScript()
end

-- GIT --
function commands:GIT()
	nextScript()
end

-- GAV --
function commands:GAV()
	nextScript()
end

-- FLG --
function commands:FLG( flag )
	story_flag = flag
	nextScript()
end

-- EDF --
function commands:EDF()
	nextScript()
end

-- EDS --
function commands:EDS()
	nextScript()
end

-- GST --
function commands:GST()
	nextScript()
end

-- BMV --
--[LUA-print] BMV('2');
function commands:BMV()
	-- ƒRƒ}ƒ“ƒhŽd—l‚ª‚í‚Á‚©‚ç‚ñ

    local l = gcclayer:getChildByTag(IMG_LOW_BG + old_BKG_id)
	local pDirector = CCDirector:sharedDirector()
	local win_size = pDirector:getWinSize()

    local move_pos_y = win_size.height / 2
    local move_pos_x = win_size.width / 2

	if old_BKG_pos == 1 then		-- ã
		move_pos_y = win_size.height / 2 + 300 * res2screen_rate

	elseif old_BKG_pos == 2 then	-- ‰E
		 move_pos_x = (win_size.width / 2) + 480 * res2screen_rate

	elseif old_BKG_pos == 3 then	-- ‰º
		move_pos_y = win_size.height / 2 - 300 * res2screen_rate

	elseif old_BKG_pos == 4 then	-- ¶
		 move_pos_x = (win_size.width / 2) - 480 * res2screen_rate
	end

	l:setVisible(true)
    local tracks = CCArray:create()
    tracks:addObject( CCMoveTo:create( 2, ccp(win_size.width / 2, win_size.height / 2) ) )
    tracks:addObject( CCMoveTo:create( 2, ccp(move_pos_x, move_pos_y) ) )
--    tracks:addObject( CCCallFunc:create(sleepOneSec) )
--    tracks:addObject( CCCallFunc:create(sleepOneSec) )
    tracks:addObject( CCCallFunc:create(nextScript) )
    l:runAction( CCSequence:create(tracks) )

-- 	nextScript()
end

-- FWG --
function commands:FWG( isVisible )
	isVisible = tonumber(isVisible)
	lualog('FWG:called: ' .. isVisible)
    local l = gcclayer:getChildByTag(IMG_LOW_FG)
	l:setVisible((isVisible == 1))
	nextScript()
end

-- CSK --
function commands:CSK( scene )
    --ƒV[ƒ“ƒXƒLƒbƒv
	--story_X ‚ÌX”Ô†B
	scene_skip_no = tonumber( scene )
	nextScript()
end

-- CLB --
function commands:CLB( scene )
    --ƒ‰ƒxƒ‹•ªŠòBlua‰»‚·‚é‘O‚Éˆ—‚©‚È‚Ÿ
	nextScript()
end

-- CSI --
function commands:CSI( id )
	-- ƒLƒƒƒ‰•ÏXEEEH
	nextScript()
end

-- CAV --
function commands:CAV()

	for i=1, MAX_CHARA, 1 do
		local chara = gcclayer:getChildByTag(IMG_LOW_CHARA + i)
	    if chara ~= nil then
	    	if DRAW_FACE_id[i] ~= -1 then
	    		lualog("DRAW_FACE_id[" .. i .. "]=" .. DRAW_FACE_id[i])
			    chara:setVisible( true )
			    chara:setOpacity(255)
			    face = chara:getChildByTag(FACE_ID_BASE_ADD + DRAW_FACE_id[i])
			    if face ~= nil then
				    face:setVisible( true )
				    face:setOpacity(255)
				end
			end
	   end
	end
    
    gcclayer:runAction( CCCallFunc:create(nextScript) )
end

-- CAH --
function commands:CAH()
	old_vis_id = -1
	old_vis_vis = -1
	for i=1, MAX_CHARA, 1 do
		local chara = gcclayer:getChildByTag(IMG_LOW_CHARA + i)
	    if chara ~= nil then
		    chara:setVisible( false )
		    chara:setOpacity(255)
	   end
	end
   
	gcclayer:runAction( CCCallFunc:create(nextScript) )
end

-- GCN --
function commands:GCN()
	nextScript()
end

